{    var   : }
{ F, M, K, INIAPR }
Unit DE88E_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE78E_p;

procedure DE88E(F :Proc_F80E; var M :Integer; XN :Extended;
                var YN :Array of Extended; var DYN :Array of Extended;
                XK :Extended; var K :Integer; var INIAPR :Integer;
                IMAX :Integer; IORDY :Integer; var H :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var NX :Integer; var XS :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; var RAB :Array of Extended);

implementation

procedure DE88E(F :Proc_F80E; var M :Integer; XN :Extended;
                var YN :Array of Extended; var DYN :Array of Extended;
                XK :Extended; var K :Integer; var INIAPR :Integer;
                IMAX :Integer; IORDY :Integer; var H :Extended;
                var Y :Array of Extended; var DY :Array of Extended;
                var NX :Integer; var XS :Array of Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var AD2Y :Array of Extended; var RAB :Array of Extended);
var
L,JSTART,IMAX0,KP1,KP2,KP3,NXAY,NXADY,NXAD2Y,I0,I1,I2,I3,I4,I5,I6,I7,
   I8,I9,I10,I11,I12,I13,I14,I15,I16,NAD2YP,J,JTP,JT :Integer;
X,HS,H1 :Extended;
BUL :Boolean;
label
_10,_30,_40,_50,_60,_70,_100;
begin
for L:=1 to M do
 begin
  Y[L-1] := YN[L-1];
_10:
  DY[L-1] := DYN[L-1];
 end;
NX := 0;
XS[0] := XN;
if ( XN = XK ) 
 then goto _100;
H := Sign(H,XK-XN);
BUL := False;
JSTART := 0;
IMAX0 := IMAX;
if ( INIAPR > 1 ) and ( IMAX <= K ) 
 then IMAX0 := K+INIAPR-1;
KP1 := K+1;
KP2 := K+2;
KP3 := K+3;
NXAY := 1;
NXADY := 1;
NXAD2Y := 1;
X := XN;
I0 := KP1;
I1 := I0+KP1;
I2 := I1+K;
I3 := I2+K;
I4 := I3+K;
I5 := I4+K*K;
I6 := I5+KP2*(K-1) div 2;
I7 := I6+KP3*K div 2;
I8 := I7+1;
I9 := I8+M;
I10 := I9+KP1*M;
I11 := I10+K*M;
I12 := I11+KP3*M;
I13 := I12+K;
I14 := I13+KP2;
I15 := I14+KP2;
I16 := I15+M;
_30:
if ( not BUL ) 
 then goto _40;
H := HS;
goto _100;
_40:
if ( JSTART = 1 ) 
 then IMAX0 := IMAX;
H1 := XK-X;
if ( Abs(H1) > Abs(H) ) 
 then goto _50;
HS := H;
H := H1;
BUL := True;
_50:
DE78E(F,M,K,INIAPR,IMAX0,JSTART,Y,DY,X,RAB[0],AY[(NXAY-1)*M],
     ADY[(NXADY-1)*M],AD2Y[(NXAD2Y-1)*M],H,RAB[I0-1],RAB[I1-1],RAB[I12-1],
     RAB[I13-1],RAB[I14-1],RAB[I2-1],RAB[I3-1],RAB[I4-1],RAB[I5-1],
     RAB[I6-1],RAB[I7-1],RAB[I8-1],RAB[I15-1],RAB[I9-1],RAB[I10-1],
     RAB[I16-1],RAB[I11-1]);
NX := NX+1;
XS[NX] := X;
NXAY := NXAY+KP3;
if ( IORDY = 0 ) 
 then goto _30;
NXADY := NXADY+KP2;
if ( IORDY = 1 ) 
 then goto _30;
if ( IORDY <> 2 ) 
 then goto _100;
if ( BUL ) 
 then goto _30;
NAD2YP := NXAD2Y;
NXAD2Y := NXAD2Y+KP1;
for J:=1 to KP1 do
 begin
  JTP := NAD2YP-1+J;
  JT := NXAD2Y-1+J;
  for L:=1 to M do
   begin
_60:
    AD2Y[(L-1)+(JT-1)*M] := AD2Y[(L-1)+(JTP-1)*M];
   end;
_70:
 end;
goto _30;
_100:
end;

end.
